
Drupal.liveCommentPreview = function() {
  textarea = $("textarea#edit-comment");
  comment_form = $("form#comment-form");

  textarea.each(function() {
    var element = Drupal.settings.live.comment.element;
    var box = '<div id="live-comment-preview"></div>';

    switch (Drupal.settings.live.comment.placement) {
      case 'prepend':
        $(box).prependTo(element);
        break;
      case 'append':
        $(box).appendTo(element);
        break;
      case 'replace':
        $(element).html(box);
        break;
      default:
        $(box).appendTo(comment_form);
        break;
    }

    $(this).keyup(update).mouseup(update).blur(update).each(function() {
      if (comment_form.find("input#edit-submit").size()) {
        // Hide "Preview comment" button, iff "Post comment" button is present.
        comment_form.siblings("input#edit-preview").hide();
      }
    });

    timer = undefined;

    function update() {
      if (timer) {
        clearTimeout(timer);
        timer = undefined
      }

      timer = setTimeout(function() {
        var comment_div = $("div#live-comment-preview");
        var body = textarea.val();
    
        if (body == "") {
          comment_div.html("");
          return;
        }

        var name = $("input#edit-name").val() || "";
        var homepage = $("input#edit-homepage").val() || "";
        var subject = $("input#edit-subject").val();
        var format = $("input[@name=format][@type=radio][@checked]").val() || 1;
        var token = $("input[@name=form_token]#edit-form-token").val() || "";

        var base_url = Drupal.settings.live.comment.base_url + '/';
        var module_path = Drupal.settings.live.comment.module_path + '/';
        var token_value = Drupal.settings.live.comment.token_value;

        jQuery.ajax({
          type: "POST",
          url: base_url + "index.php?q=live/comment/preview",
          data: {
            name: name,
            homepage: homepage,
            subject: subject,
            body: body,
            format: format,
            token: token,
            token_value: token_value
          },
          timeout: 5000,
          beforeSend: function() {
            $('body').append('<div class="live-progress-panel">Loading...</div>');
          },
          success: function(data){
            comment_div.html(data);
            $('div.live-progress-panel').remove();
          },
          error: function() {
            $('div.live-progress-panel').html('Error requesting data!');
            comment_div.fadeOut("slow");
            setTimeout(function() { $('div.live-progress-panel').remove(); }, 2500);
          }
        });
      }, Drupal.settings.live.comment.refresh_delay);
    }
  });
};

if (Drupal.jsEnabled) {
  $(document).ready(Drupal.liveCommentPreview);
}
